      module mo_lin_matrix
      use chem_mods, only: veclen
      private
      public :: linmat
      contains
      subroutine linmat01( avec_len, mat, y, rxt, het_rates )
!----------------------------------------------
! ... linear matrix entries for implicit species
!----------------------------------------------
      use chem_mods, only : gas_pcnst, rxntot, nzcnt
      use shr_kind_mod, only : r8 => shr_kind_r8
      implicit none
!----------------------------------------------
! ... dummy arguments
!----------------------------------------------
      integer, intent(in) :: avec_len
      real(r8), intent(in) :: y(veclen,gas_pcnst)
      real(r8), intent(in) :: rxt(veclen,rxntot)
      real(r8), intent(in) :: het_rates(veclen,gas_pcnst)
      real(r8), intent(inout) :: mat(veclen,nzcnt)
!----------------------------------------------
! ... local variables
!----------------------------------------------
      integer :: k
      do k = 1,avec_len
         mat(k,533) = -( rxt(k,19) + het_rates(k,1) )
         mat(k,522) = -( rxt(k,20) + het_rates(k,2) )
         mat(k,1) = -( het_rates(k,4) )
         mat(k,2) = -( het_rates(k,5) )
         mat(k,761) = -( het_rates(k,6) )
         mat(k,81) = -( het_rates(k,7) )
         mat(k,284) = -( rxt(k,21) + het_rates(k,8) )
         mat(k,87) = -( rxt(k,22) + het_rates(k,9) )
         mat(k,290) = -( rxt(k,23) + het_rates(k,10) )
         mat(k,353) = -( rxt(k,24) + het_rates(k,11) )
         mat(k,285) = .500_r8*rxt(k,21)
         mat(k,88) = rxt(k,22)
         mat(k,493) = .200_r8*rxt(k,70)
         mat(k,561) = .060_r8*rxt(k,72)
         mat(k,190) = -( rxt(k,25) + het_rates(k,12) )
         mat(k,492) = .200_r8*rxt(k,70)
         mat(k,559) = .200_r8*rxt(k,72)
         mat(k,503) = -( rxt(k,26) + het_rates(k,13) )
         mat(k,151) = rxt(k,46)
         mat(k,870) = rxt(k,56)
         mat(k,495) = .200_r8*rxt(k,70)
         mat(k,562) = .150_r8*rxt(k,72)
         mat(k,224) = -( rxt(k,27) + het_rates(k,14) )
         mat(k,560) = .210_r8*rxt(k,72)
         mat(k,158) = -( het_rates(k,15) )
         mat(k,258) = -( het_rates(k,16) )
         mat(k,1250) = -( het_rates(k,17) )
         mat(k,162) = rxt(k,74)
         mat(k,1849) = rxt(k,75)
         mat(k,445) = rxt(k,77)
         mat(k,696) = rxt(k,99)
         mat(k,641) = rxt(k,105)
         mat(k,1467) = rxt(k,200)*y(k,34) + rxt(k,226)*y(k,35) &
                      + 3.000_r8*rxt(k,227)*y(k,55) + 2.000_r8*rxt(k,228)*y(k,78) &
                      + 2.000_r8*rxt(k,249)*y(k,41) + rxt(k,250)*y(k,43)
         mat(k,1724) = 2.000_r8*rxt(k,237)*y(k,41) + rxt(k,239)*y(k,43) &
                      + 3.000_r8*rxt(k,244)*y(k,55)
         mat(k,1614) = 2.000_r8*rxt(k,238)*y(k,41) + rxt(k,240)*y(k,43) &
                      + 3.000_r8*rxt(k,245)*y(k,55)
         mat(k,161) = -( rxt(k,74) + het_rates(k,18) )
         mat(k,1862) = -( rxt(k,75) + het_rates(k,19) )
         mat(k,449) = rxt(k,76)
         mat(k,443) = -( rxt(k,76) + rxt(k,77) + rxt(k,510) + rxt(k,513) + rxt(k,518) &
                 + het_rates(k,20) )
         mat(k,164) = -( het_rates(k,22) )
         mat(k,239) = rxt(k,28)
         mat(k,240) = -( rxt(k,28) + het_rates(k,23) )
         mat(k,199) = -( het_rates(k,24) )
         mat(k,451) = -( het_rates(k,25) )
         mat(k,172) = -( het_rates(k,26) )
         mat(k,245) = -( rxt(k,29) + het_rates(k,27) )
         mat(k,205) = -( het_rates(k,28) )
         mat(k,841) = -( het_rates(k,29) )
         mat(k,1125) = .700_r8*rxt(k,55)
         mat(k,314) = -( rxt(k,30) + het_rates(k,30) )
         mat(k,55) = -( het_rates(k,31) )
         mat(k,176) = -( rxt(k,31) + het_rates(k,32) )
         mat(k,1917) = -( rxt(k,32) + rxt(k,33) + het_rates(k,42) )
         mat(k,542) = .100_r8*rxt(k,19)
         mat(k,531) = .100_r8*rxt(k,20)
         mat(k,324) = rxt(k,38)
         mat(k,869) = rxt(k,43)
         mat(k,909) = .330_r8*rxt(k,45)
         mat(k,920) = rxt(k,47)
         mat(k,558) = .690_r8*rxt(k,49)
         mat(k,1069) = 1.340_r8*rxt(k,50)
         mat(k,737) = rxt(k,57)
         mat(k,441) = rxt(k,62)
         mat(k,306) = rxt(k,63)
         mat(k,491) = .375_r8*rxt(k,65)
         mat(k,373) = .400_r8*rxt(k,67)
         mat(k,893) = .680_r8*rxt(k,69)
         mat(k,344) = rxt(k,269)
         mat(k,183) = 2.000_r8*rxt(k,299)
         mat(k,1482) = rxt(k,272)*y(k,54) + rxt(k,273)*y(k,54)
         mat(k,996) = -( rxt(k,34) + het_rates(k,45) )
         mat(k,537) = .400_r8*rxt(k,19)
         mat(k,527) = .400_r8*rxt(k,20)
         mat(k,247) = rxt(k,29)
         mat(k,902) = .330_r8*rxt(k,45)
         mat(k,221) = rxt(k,53)
         mat(k,438) = rxt(k,62)
         mat(k,52) = -( het_rates(k,47) )
         mat(k,819) = -( rxt(k,35) + het_rates(k,48) )
         mat(k,536) = .250_r8*rxt(k,19)
         mat(k,526) = .250_r8*rxt(k,20)
         mat(k,316) = .820_r8*rxt(k,30)
         mat(k,896) = .170_r8*rxt(k,45)
         mat(k,484) = .300_r8*rxt(k,65)
         mat(k,368) = .050_r8*rxt(k,67)
         mat(k,885) = .500_r8*rxt(k,69)
         mat(k,1072) = -( rxt(k,36) + het_rates(k,49) )
         mat(k,293) = .180_r8*rxt(k,23)
         mat(k,226) = rxt(k,27)
         mat(k,500) = .400_r8*rxt(k,70)
         mat(k,570) = .540_r8*rxt(k,72)
         mat(k,329) = .510_r8*rxt(k,73)
         mat(k,431) = -( het_rates(k,50) )
         mat(k,391) = -( rxt(k,37) + het_rates(k,51) )
         mat(k,661) = -( het_rates(k,52) )
         mat(k,320) = -( rxt(k,38) + het_rates(k,53) )
         mat(k,1734) = -( rxt(k,175)*y(k,54) + rxt(k,237)*y(k,41) + rxt(k,239)*y(k,43) &
                      + rxt(k,242)*y(k,46) + rxt(k,244)*y(k,55) + het_rates(k,56) )
         mat(k,163) = rxt(k,74)
         mat(k,75) = 2.000_r8*rxt(k,91)
         mat(k,48) = 2.000_r8*rxt(k,92)
         mat(k,1700) = rxt(k,93)
         mat(k,833) = rxt(k,94)
         mat(k,103) = rxt(k,97)
         mat(k,1303) = rxt(k,103)
         mat(k,681) = rxt(k,106)
         mat(k,1477) = 4.000_r8*rxt(k,199)*y(k,33) + rxt(k,200)*y(k,34) &
                      + 2.000_r8*rxt(k,201)*y(k,36) + 2.000_r8*rxt(k,202)*y(k,37) &
                      + 2.000_r8*rxt(k,203)*y(k,38) + rxt(k,204)*y(k,39) &
                      + 2.000_r8*rxt(k,205)*y(k,40) + rxt(k,251)*y(k,82) &
                      + rxt(k,252)*y(k,83) + rxt(k,253)*y(k,84)
         mat(k,1624) = 3.000_r8*rxt(k,241)*y(k,44) + rxt(k,243)*y(k,46) &
                      + rxt(k,246)*y(k,82) + rxt(k,247)*y(k,83) + rxt(k,248)*y(k,84)
         mat(k,74) = -( rxt(k,91) + het_rates(k,57) )
         mat(k,46) = -( rxt(k,92) + rxt(k,209) + het_rates(k,58) )
         mat(k,1699) = -( rxt(k,93) + het_rates(k,59) )
         mat(k,832) = rxt(k,95)
         mat(k,232) = rxt(k,107)
         mat(k,47) = 2.000_r8*rxt(k,209)
         mat(k,827) = -( rxt(k,94) + rxt(k,95) + rxt(k,512) + rxt(k,517) + rxt(k,523) &
                 + het_rates(k,60) )
         mat(k,911) = -( het_rates(k,62) )
         mat(k,89) = 1.500_r8*rxt(k,22)
         mat(k,292) = .450_r8*rxt(k,23)
         mat(k,505) = .600_r8*rxt(k,26)
         mat(k,225) = rxt(k,27)
         mat(k,1900) = rxt(k,32) + rxt(k,33)
         mat(k,995) = rxt(k,34)
         mat(k,1071) = rxt(k,36)
         mat(k,866) = rxt(k,43)
         mat(k,740) = 2.000_r8*rxt(k,44)
         mat(k,899) = .330_r8*rxt(k,45)
         mat(k,1059) = 1.340_r8*rxt(k,51)
         mat(k,1126) = .700_r8*rxt(k,55)
         mat(k,122) = 1.500_r8*rxt(k,64)
         mat(k,487) = .250_r8*rxt(k,65)
         mat(k,858) = rxt(k,68)
         mat(k,887) = 1.700_r8*rxt(k,69)
         mat(k,253) = rxt(k,110)
         mat(k,1720) = rxt(k,242)*y(k,46)
         mat(k,59) = -( rxt(k,96) + het_rates(k,64) )
         mat(k,1461) = rxt(k,200)*y(k,34) + rxt(k,202)*y(k,37) &
                      + 2.000_r8*rxt(k,203)*y(k,38) + 2.000_r8*rxt(k,204)*y(k,39) &
                      + rxt(k,205)*y(k,40) + rxt(k,226)*y(k,35) &
                      + 2.000_r8*rxt(k,228)*y(k,78) + rxt(k,252)*y(k,83) &
                      + rxt(k,253)*y(k,84)
         mat(k,1495) = rxt(k,247)*y(k,83) + rxt(k,248)*y(k,84)
         mat(k,100) = -( rxt(k,97) + het_rates(k,65) )
         mat(k,1463) = rxt(k,201)*y(k,36) + rxt(k,202)*y(k,37) + rxt(k,251)*y(k,82)
         mat(k,1501) = rxt(k,246)*y(k,82)
         mat(k,116) = -( het_rates(k,66) )
         mat(k,193) = -( het_rates(k,67) )
         mat(k,3) = -( het_rates(k,68) )
         mat(k,4) = -( het_rates(k,69) )
         mat(k,5) = -( het_rates(k,70) )
         mat(k,62) = -( rxt(k,42) + het_rates(k,72) )
         mat(k,649) = -( rxt(k,231)*y(k,54) + het_rates(k,73) )
         mat(k,60) = 2.000_r8*rxt(k,96)
         mat(k,101) = rxt(k,97)
         mat(k,148) = rxt(k,104)
         mat(k,1464) = rxt(k,204)*y(k,39) + rxt(k,226)*y(k,35)
         mat(k,865) = -( rxt(k,43) + het_rates(k,74) )
         mat(k,897) = .330_r8*rxt(k,45)
         mat(k,485) = .250_r8*rxt(k,65)
         mat(k,181) = rxt(k,300)
         mat(k,739) = -( rxt(k,44) + rxt(k,480) + het_rates(k,75) )
         mat(k,287) = rxt(k,21)
         mat(k,291) = .130_r8*rxt(k,23)
         mat(k,236) = .700_r8*rxt(k,61)
         mat(k,499) = .600_r8*rxt(k,70)
         mat(k,567) = .340_r8*rxt(k,72)
         mat(k,328) = .170_r8*rxt(k,73)
         mat(k,1276) = -( rxt(k,137) + het_rates(k,76) )
         mat(k,2007) = rxt(k,2) + 2.000_r8*rxt(k,3)
         mat(k,1904) = 2.000_r8*rxt(k,32)
         mat(k,321) = rxt(k,38)
         mat(k,697) = rxt(k,99)
         mat(k,1295) = rxt(k,103)
         mat(k,149) = rxt(k,104)
         mat(k,1469) = rxt(k,272)*y(k,54)
         mat(k,1007) = -( het_rates(k,77) )
         mat(k,2003) = rxt(k,1)
         mat(k,1901) = rxt(k,33)
         mat(k,1466) = rxt(k,273)*y(k,54)
         mat(k,476) = -( rxt(k,4) + het_rates(k,79) )
         mat(k,1339) = .500_r8*rxt(k,481)
         mat(k,65) = -( rxt(k,109) + het_rates(k,80) )
         mat(k,695) = -( rxt(k,99) + het_rates(k,81) )
         mat(k,1296) = -( rxt(k,103) + het_rates(k,85) )
         mat(k,1727) = rxt(k,175)*y(k,54) + rxt(k,237)*y(k,41) + rxt(k,239)*y(k,43) &
                      + 2.000_r8*rxt(k,242)*y(k,46) + rxt(k,244)*y(k,55)
         mat(k,96) = -( het_rates(k,86) )
         mat(k,657) = -( het_rates(k,87) )
         mat(k,147) = -( rxt(k,104) + het_rates(k,88) )
         mat(k,648) = rxt(k,231)*y(k,54)
         mat(k,1263) = -( rxt(k,9) + het_rates(k,89) )
         mat(k,904) = rxt(k,482)
         mat(k,471) = rxt(k,483)
         mat(k,428) = rxt(k,484)
         mat(k,185) = 2.000_r8*rxt(k,485) + 2.000_r8*rxt(k,508) + 2.000_r8*rxt(k,511) &
                      + 2.000_r8*rxt(k,522)
         mat(k,281) = rxt(k,486)
         mat(k,878) = rxt(k,487)
         mat(k,1766) = .500_r8*rxt(k,489)
         mat(k,1444) = rxt(k,490)
         mat(k,299) = rxt(k,491)
         mat(k,156) = rxt(k,492)
         mat(k,509) = rxt(k,493)
         mat(k,446) = rxt(k,510) + rxt(k,513) + rxt(k,518)
         mat(k,828) = rxt(k,512) + rxt(k,517) + rxt(k,523)
      end do
      end subroutine linmat01
      subroutine linmat02( avec_len, mat, y, rxt, het_rates )
!----------------------------------------------
! ... linear matrix entries for implicit species
!----------------------------------------------
      use chem_mods, only : gas_pcnst, rxntot, nzcnt
      use shr_kind_mod, only : r8 => shr_kind_r8
      implicit none
!----------------------------------------------
! ... dummy arguments
!----------------------------------------------
      integer, intent(in) :: avec_len
      real(r8), intent(in) :: y(veclen,gas_pcnst)
      real(r8), intent(in) :: rxt(veclen,rxntot)
      real(r8), intent(in) :: het_rates(veclen,gas_pcnst)
      real(r8), intent(inout) :: mat(veclen,nzcnt)
!----------------------------------------------
! ... local variables
!----------------------------------------------
      integer :: k
      do k = 1,avec_len
         mat(k,272) = -( rxt(k,10) + rxt(k,11) + rxt(k,172) + het_rates(k,90) )
         mat(k,640) = -( rxt(k,105) + het_rates(k,91) )
         mat(k,444) = rxt(k,510) + rxt(k,513) + rxt(k,518)
         mat(k,677) = -( rxt(k,106) + het_rates(k,92) )
         mat(k,826) = rxt(k,512) + rxt(k,517) + rxt(k,523)
         mat(k,898) = -( rxt(k,45) + rxt(k,482) + het_rates(k,93) )
         mat(k,150) = -( rxt(k,46) + het_rates(k,94) )
         mat(k,1166) = rxt(k,373)
         mat(k,915) = -( rxt(k,47) + het_rates(k,95) )
         mat(k,900) = .170_r8*rxt(k,45)
         mat(k,211) = -( het_rates(k,96) )
         mat(k,68) = -( het_rates(k,97) )
         mat(k,709) = -( het_rates(k,98) )
         mat(k,467) = -( rxt(k,483) + het_rates(k,99) )
         mat(k,423) = -( rxt(k,484) + het_rates(k,100) )
         mat(k,1044) = -( het_rates(k,101) )
         mat(k,308) = -( rxt(k,48) + het_rates(k,102) )
         mat(k,552) = -( rxt(k,49) + het_rates(k,103) )
         mat(k,309) = rxt(k,48)
         mat(k,39) = -( het_rates(k,104) )
         mat(k,1060) = -( rxt(k,50) + rxt(k,51) + het_rates(k,105) )
         mat(k,554) = .288_r8*rxt(k,49)
         mat(k,214) = -( het_rates(k,106) )
         mat(k,403) = -( rxt(k,52) + het_rates(k,107) )
         mat(k,532) = .800_r8*rxt(k,19)
         mat(k,521) = .800_r8*rxt(k,20)
         mat(k,219) = -( rxt(k,53) + het_rates(k,108) )
         mat(k,415) = -( rxt(k,54) + rxt(k,355) + het_rates(k,109) )
         mat(k,787) = -( het_rates(k,110) )
         mat(k,1130) = -( rxt(k,55) + het_rates(k,111) )
         mat(k,555) = .402_r8*rxt(k,49)
         mat(k,266) = -( rxt(k,154) + het_rates(k,112) )
         mat(k,1926) = rxt(k,15)
         mat(k,184) = -( rxt(k,13) + rxt(k,14) + rxt(k,173) + rxt(k,485) + rxt(k,508) &
                      + rxt(k,511) + rxt(k,522) + het_rates(k,114) )
         mat(k,278) = -( rxt(k,486) + het_rates(k,115) )
         mat(k,874) = -( rxt(k,56) + rxt(k,487) + het_rates(k,116) )
         mat(k,6) = -( het_rates(k,117) )
         mat(k,7) = -( het_rates(k,118) )
         mat(k,8) = -( het_rates(k,119) )
         mat(k,49) = -( het_rates(k,120) )
         mat(k,9) = -( rxt(k,488) + het_rates(k,121) )
         mat(k,1996) = -( rxt(k,15) + het_rates(k,124) )
         mat(k,189) = rxt(k,14)
         mat(k,1781) = rxt(k,16) + .500_r8*rxt(k,489)
         mat(k,1459) = rxt(k,17)
         mat(k,271) = rxt(k,154)
         mat(k,1483) = 2.000_r8*rxt(k,166)*y(k,113)
         mat(k,1776) = -( rxt(k,16) + rxt(k,489) + het_rates(k,125) )
         mat(k,1271) = rxt(k,9)
         mat(k,276) = rxt(k,11) + rxt(k,172)
         mat(k,187) = rxt(k,13) + rxt(k,173)
         mat(k,1454) = rxt(k,18)
         mat(k,541) = rxt(k,19)
         mat(k,908) = rxt(k,45)
         mat(k,313) = rxt(k,48)
         mat(k,421) = rxt(k,54) + rxt(k,355)
         mat(k,882) = rxt(k,56)
         mat(k,736) = rxt(k,57)
         mat(k,301) = rxt(k,58)
         mat(k,157) = rxt(k,59)
         mat(k,361) = .600_r8*rxt(k,60) + rxt(k,306)
         mat(k,512) = rxt(k,66)
         mat(k,448) = rxt(k,76)
         mat(k,834) = rxt(k,95)
         mat(k,73) = rxt(k,430)
         mat(k,1448) = -( rxt(k,17) + rxt(k,18) + rxt(k,490) + het_rates(k,126) )
         mat(k,274) = rxt(k,10)
         mat(k,186) = rxt(k,13) + rxt(k,14) + rxt(k,173)
         mat(k,358) = .400_r8*rxt(k,60)
         mat(k,447) = rxt(k,77)
         mat(k,830) = rxt(k,94)
         mat(k,732) = -( rxt(k,57) + het_rates(k,127) )
         mat(k,296) = -( rxt(k,58) + rxt(k,491) + het_rates(k,128) )
         mat(k,10) = -( het_rates(k,129) )
         mat(k,11) = -( het_rates(k,130) )
         mat(k,12) = -( het_rates(k,131) )
         mat(k,13) = -( het_rates(k,132) )
         mat(k,1893) = -( rxt(k,131) + het_rates(k,133) )
         mat(k,2019) = rxt(k,3)
         mat(k,1839) = rxt(k,8)
         mat(k,188) = rxt(k,14)
         mat(k,1994) = rxt(k,15)
         mat(k,1779) = rxt(k,16)
         mat(k,1457) = rxt(k,18)
         mat(k,1863) = rxt(k,75)
         mat(k,1704) = rxt(k,93)
         mat(k,233) = rxt(k,107)
         mat(k,1093) = rxt(k,111) + rxt(k,470)
         mat(k,730) = rxt(k,112)
         mat(k,170) = rxt(k,113)
         mat(k,1481) = rxt(k,126) + rxt(k,127)
         mat(k,270) = rxt(k,154)
         mat(k,402) = rxt(k,464)
         mat(k,1837) = -( rxt(k,7) + rxt(k,8) + het_rates(k,134) )
         mat(k,1891) = rxt(k,131)
         mat(k,229) = -( rxt(k,107) + het_rates(k,135) )
         mat(k,250) = -( rxt(k,110) + het_rates(k,136) )
         mat(k,155) = -( rxt(k,59) + rxt(k,492) + het_rates(k,137) )
         mat(k,356) = -( rxt(k,60) + rxt(k,306) + het_rates(k,138) )
         mat(k,71) = -( rxt(k,430) + het_rates(k,139) )
         mat(k,363) = -( het_rates(k,140) )
         mat(k,177) = rxt(k,31)
         mat(k,91) = -( het_rates(k,141) )
         mat(k,234) = -( rxt(k,61) + het_rates(k,142) )
         mat(k,14) = -( het_rates(k,143) )
         mat(k,15) = -( het_rates(k,144) )
         mat(k,435) = -( rxt(k,62) + het_rates(k,145) )
         mat(k,302) = -( rxt(k,63) + het_rates(k,146) )
         mat(k,397) = -( rxt(k,464) + het_rates(k,147) )
         mat(k,251) = rxt(k,110)
         mat(k,1081) = rxt(k,111)
         mat(k,1083) = -( rxt(k,111) + rxt(k,470) + het_rates(k,149) )
         mat(k,727) = rxt(k,112)
         mat(k,398) = rxt(k,464)
         mat(k,726) = -( rxt(k,112) + het_rates(k,150) )
         mat(k,169) = rxt(k,113)
         mat(k,1082) = rxt(k,470)
         mat(k,168) = -( rxt(k,113) + het_rates(k,151) )
         mat(k,66) = rxt(k,109)
         mat(k,16) = -( het_rates(k,152) )
         mat(k,17) = -( het_rates(k,153) )
         mat(k,18) = -( het_rates(k,154) )
         mat(k,19) = -( rxt(k,114) + het_rates(k,155) )
         mat(k,20) = -( rxt(k,115) + het_rates(k,156) )
         mat(k,21) = -( rxt(k,116) + het_rates(k,157) )
         mat(k,22) = -( rxt(k,117) + het_rates(k,158) )
         mat(k,23) = -( rxt(k,118) + het_rates(k,159) )
         mat(k,24) = -( rxt(k,119) + het_rates(k,160) )
         mat(k,25) = -( rxt(k,120) + het_rates(k,161) )
         mat(k,26) = -( rxt(k,121) + het_rates(k,162) )
         mat(k,27) = -( rxt(k,122) + het_rates(k,163) )
         mat(k,28) = -( rxt(k,123) + het_rates(k,164) )
         mat(k,29) = -( het_rates(k,165) )
         mat(k,738) = rxt(k,480)
         mat(k,30) = -( het_rates(k,166) )
         mat(k,31) = -( het_rates(k,167) )
         mat(k,32) = -( het_rates(k,168) )
         mat(k,33) = -( het_rates(k,169) )
         mat(k,45) = -( het_rates(k,171) )
         mat(k,121) = -( rxt(k,64) + het_rates(k,172) )
         mat(k,483) = -( rxt(k,65) + het_rates(k,173) )
         mat(k,507) = -( rxt(k,66) + rxt(k,493) + het_rates(k,174) )
         mat(k,367) = -( rxt(k,67) + het_rates(k,175) )
         mat(k,856) = -( rxt(k,68) + het_rates(k,176) )
         mat(k,297) = rxt(k,58)
         mat(k,508) = rxt(k,66)
         mat(k,369) = rxt(k,67)
         mat(k,886) = -( rxt(k,69) + het_rates(k,177) )
         mat(k,486) = rxt(k,65)
         mat(k,857) = rxt(k,68)
         mat(k,494) = -( rxt(k,70) + het_rates(k,178) )
         mat(k,109) = -( het_rates(k,179) )
         mat(k,125) = -( rxt(k,71) + het_rates(k,180) )
         mat(k,134) = -( het_rates(k,181) )
         mat(k,563) = -( rxt(k,72) + het_rates(k,182) )
         mat(k,142) = -( het_rates(k,183) )
         mat(k,326) = -( rxt(k,73) + het_rates(k,184) )
         mat(k,409) = -( het_rates(k,187) )
         mat(k,72) = rxt(k,430)
         mat(k,809) = -( het_rates(k,188) )
         mat(k,376) = -( het_rates(k,189) )
         mat(k,334) = -( het_rates(k,190) )
         mat(k,687) = -( het_rates(k,191) )
         mat(k,405) = rxt(k,52)
         mat(k,666) = -( het_rates(k,192) )
         mat(k,515) = -( het_rates(k,193) )
         mat(k,1236) = -( het_rates(k,194) )
         mat(k,294) = .130_r8*rxt(k,23)
         mat(k,227) = rxt(k,27)
         mat(k,821) = rxt(k,35)
         mat(k,1073) = rxt(k,36)
         mat(k,903) = .330_r8*rxt(k,45)
         mat(k,917) = rxt(k,47)
         mat(k,1064) = 1.340_r8*rxt(k,50)
         mat(k,406) = rxt(k,52)
         mat(k,222) = rxt(k,53)
         mat(k,1132) = .300_r8*rxt(k,55)
         mat(k,734) = rxt(k,57)
         mat(k,357) = .600_r8*rxt(k,60) + rxt(k,306)
         mat(k,304) = rxt(k,63)
         mat(k,123) = .500_r8*rxt(k,64)
         mat(k,889) = .650_r8*rxt(k,69)
         mat(k,1672) = -( het_rates(k,195) )
         mat(k,1003) = rxt(k,34)
         mat(k,823) = rxt(k,35)
         mat(k,394) = rxt(k,37)
         mat(k,1138) = .300_r8*rxt(k,55)
         mat(k,360) = .400_r8*rxt(k,60)
         mat(k,1732) = rxt(k,175)*y(k,54)
         mat(k,655) = rxt(k,231)*y(k,54)
         mat(k,1622) = rxt(k,264)*y(k,54)
         mat(k,1475) = rxt(k,271)*y(k,54)
         mat(k,621) = -( het_rates(k,196) )
         mat(k,191) = .600_r8*rxt(k,25)
         mat(k,459) = -( het_rates(k,197) )
         mat(k,180) = -( rxt(k,299) + rxt(k,300) + het_rates(k,198) )
         mat(k,63) = rxt(k,42)
         mat(k,576) = -( het_rates(k,199) )
         mat(k,1390) = -( rxt(k,481) + het_rates(k,200) )
         mat(k,273) = rxt(k,11) + rxt(k,172)
         mat(k,539) = rxt(k,19)
         mat(k,529) = .900_r8*rxt(k,20)
         mat(k,288) = rxt(k,21)
         mat(k,90) = 1.500_r8*rxt(k,22)
         mat(k,295) = .560_r8*rxt(k,23)
         mat(k,355) = rxt(k,24)
         mat(k,192) = .600_r8*rxt(k,25)
         mat(k,506) = .600_r8*rxt(k,26)
         mat(k,228) = rxt(k,27)
         mat(k,243) = rxt(k,28)
         mat(k,248) = rxt(k,29)
         mat(k,317) = rxt(k,30)
         mat(k,1000) = rxt(k,34)
         mat(k,1076) = rxt(k,36)
         mat(k,867) = 2.000_r8*rxt(k,43)
         mat(k,741) = 2.000_r8*rxt(k,44)
         mat(k,905) = .670_r8*rxt(k,45)
         mat(k,153) = rxt(k,46)
         mat(k,918) = rxt(k,47)
         mat(k,311) = rxt(k,48)
         mat(k,556) = rxt(k,49)
         mat(k,1066) = 1.340_r8*rxt(k,50) + .660_r8*rxt(k,51)
         mat(k,879) = rxt(k,56)
         mat(k,237) = rxt(k,61)
         mat(k,439) = rxt(k,62)
         mat(k,124) = rxt(k,64)
         mat(k,489) = rxt(k,65)
         mat(k,510) = rxt(k,66)
         mat(k,371) = rxt(k,67)
         mat(k,861) = rxt(k,68)
         mat(k,890) = 1.200_r8*rxt(k,69)
         mat(k,501) = rxt(k,70)
         mat(k,572) = rxt(k,72)
         mat(k,330) = rxt(k,73)
         mat(k,1278) = rxt(k,137)
         mat(k,342) = rxt(k,269)
         mat(k,182) = rxt(k,299) + rxt(k,300)
         mat(k,1191) = rxt(k,373)
         mat(k,1728) = rxt(k,239)*y(k,43) + rxt(k,242)*y(k,46)
         mat(k,1618) = rxt(k,240)*y(k,43) + rxt(k,243)*y(k,46)
         mat(k,1471) = rxt(k,272)*y(k,54)
      end do
      end subroutine linmat02
      subroutine linmat03( avec_len, mat, y, rxt, het_rates )
!----------------------------------------------
! ... linear matrix entries for implicit species
!----------------------------------------------
      use chem_mods, only : gas_pcnst, rxntot, nzcnt
      use shr_kind_mod, only : r8 => shr_kind_r8
      implicit none
!----------------------------------------------
! ... dummy arguments
!----------------------------------------------
      integer, intent(in) :: avec_len
      real(r8), intent(in) :: y(veclen,gas_pcnst)
      real(r8), intent(in) :: rxt(veclen,rxntot)
      real(r8), intent(in) :: het_rates(veclen,gas_pcnst)
      real(r8), intent(inout) :: mat(veclen,nzcnt)
!----------------------------------------------
! ... local variables
!----------------------------------------------
      integer :: k
      do k = 1,avec_len
         mat(k,340) = -( rxt(k,269) + het_rates(k,201) )
         mat(k,1108) = -( het_rates(k,202) )
         mat(k,1186) = -( rxt(k,373) + het_rates(k,203) )
         mat(k,1153) = -( het_rates(k,204) )
         mat(k,583) = -( het_rates(k,205) )
         mat(k,354) = .600_r8*rxt(k,24)
         mat(k,1205) = -( het_rates(k,206) )
         mat(k,1063) = .660_r8*rxt(k,50)
         mat(k,417) = rxt(k,54) + rxt(k,355)
         mat(k,744) = -( het_rates(k,207) )
         mat(k,504) = .600_r8*rxt(k,26)
         mat(k,544) = -( het_rates(k,208) )
         mat(k,969) = -( het_rates(k,209) )
         mat(k,1473) = -( rxt(k,126) + rxt(k,127) + rxt(k,166)*y(k,113) &
                      + rxt(k,167)*y(k,113) + rxt(k,199)*y(k,33) + rxt(k,200)*y(k,34) &
                      + rxt(k,201)*y(k,36) + rxt(k,202)*y(k,37) + rxt(k,203)*y(k,38) &
                      + rxt(k,204)*y(k,39) + rxt(k,205)*y(k,40) + rxt(k,226)*y(k,35) &
                      + rxt(k,227)*y(k,55) + rxt(k,228)*y(k,78) + rxt(k,249)*y(k,41) &
                      + rxt(k,250)*y(k,43) + rxt(k,251)*y(k,82) + rxt(k,252)*y(k,83) &
                      + rxt(k,253)*y(k,84) + rxt(k,271)*y(k,54) + rxt(k,272)*y(k,54) &
                      + rxt(k,273)*y(k,54) + het_rates(k,210) )
         mat(k,2011) = rxt(k,1)
         mat(k,1831) = rxt(k,7)
         mat(k,1621) = -( rxt(k,238)*y(k,41) + rxt(k,240)*y(k,43) + rxt(k,241)*y(k,44) &
                      + rxt(k,243)*y(k,46) + rxt(k,245)*y(k,55) + rxt(k,246)*y(k,82) &
                      + rxt(k,247)*y(k,83) + rxt(k,248)*y(k,84) + rxt(k,264)*y(k,54) &
                 + het_rates(k,211) )
         mat(k,2012) = rxt(k,2)
         mat(k,479) = 2.000_r8*rxt(k,4)
         mat(k,1268) = rxt(k,9)
         mat(k,275) = rxt(k,10)
         mat(k,530) = rxt(k,20)
         mat(k,289) = rxt(k,21)
         mat(k,244) = rxt(k,28)
         mat(k,249) = rxt(k,29)
         mat(k,318) = rxt(k,30)
         mat(k,179) = rxt(k,31)
         mat(k,393) = rxt(k,37)
         mat(k,322) = rxt(k,38)
         mat(k,64) = rxt(k,42)
         mat(k,154) = rxt(k,46)
         mat(k,223) = rxt(k,53)
         mat(k,300) = rxt(k,58)
         mat(k,238) = rxt(k,61)
         mat(k,440) = rxt(k,62)
         mat(k,305) = rxt(k,63)
         mat(k,490) = rxt(k,65)
         mat(k,372) = rxt(k,67)
         mat(k,502) = rxt(k,70)
         mat(k,127) = rxt(k,71)
         mat(k,573) = rxt(k,72)
         mat(k,331) = rxt(k,73)
         mat(k,643) = rxt(k,105)
         mat(k,679) = rxt(k,106)
         mat(k,1772) = .500_r8*rxt(k,489)
         mat(k,1474) = rxt(k,271)*y(k,54)
         mat(k,347) = -( het_rates(k,212) )
         mat(k,630) = -( het_rates(k,213) )
         mat(k,985) = -( het_rates(k,214) )
         mat(k,888) = .150_r8*rxt(k,69)
         mat(k,950) = -( het_rates(k,215) )
         mat(k,928) = -( het_rates(k,216) )
         mat(k,594) = -( het_rates(k,217) )
         mat(k,1024) = -( het_rates(k,218) )
         mat(k,610) = -( het_rates(k,219) )
         mat(k,384) = -( het_rates(k,220) )
         mat(k,2022) = -( rxt(k,1) + rxt(k,2) + rxt(k,3) + het_rates(k,221) )
         mat(k,67) = rxt(k,109)
         mat(k,1631) = rxt(k,238)*y(k,41) + rxt(k,240)*y(k,43) + rxt(k,241)*y(k,44) &
                      + rxt(k,243)*y(k,46) + rxt(k,248)*y(k,84) + rxt(k,264)*y(k,54)
      end do
      end subroutine linmat03
      subroutine linmat( avec_len, mat, y, rxt, het_rates )
!----------------------------------------------
! ... linear matrix entries for implicit species
!----------------------------------------------
      use chem_mods, only : gas_pcnst, rxntot, nzcnt
      use shr_kind_mod, only : r8 => shr_kind_r8
      implicit none
!----------------------------------------------
! ... dummy arguments
!----------------------------------------------
      integer, intent(in) :: avec_len
      real(r8), intent(in) :: y(veclen,gas_pcnst)
      real(r8), intent(in) :: rxt(veclen,rxntot)
      real(r8), intent(in) :: het_rates(veclen,gas_pcnst)
      real(r8), intent(inout) :: mat(veclen,nzcnt)
      call linmat01( avec_len, mat, y, rxt, het_rates )
      call linmat02( avec_len, mat, y, rxt, het_rates )
      call linmat03( avec_len, mat, y, rxt, het_rates )
      end subroutine linmat
      end module mo_lin_matrix
